package org.somda.protosdc.discovery.consumer

import kotlinx.coroutines.Deferred
import kotlinx.coroutines.channels.ReceiveChannel
import org.somda.protosdc.common.Service
import org.somda.protosdc.network.udp.UdpMessageQueue
import org.somda.protosdc.proto.model.discovery.Endpoint
import org.somda.protosdc.proto.model.discovery.SearchFilter
import java.net.URI

/**
 * A [Deferred] including a token to identify a search request on notifications from [DiscoveryConsumer.subscribe].
 *
 * @param searchId the search identifier generated by a [DiscoveryConsumer].
 */
public class DeferredSearchResult<T>(
    public val searchId: String,
    deferred: Deferred<T>
) : Deferred<T> by deferred

/**
 * Specification of a discovery consumer to seek endpoints on the network.
 */
public interface DiscoveryConsumer : Service {

    public interface Factory {
        /**
         * @param udpMessageQueue a UDP message queue used to capture and send UDP messages in ad-hoc mode.
         * @param discoveryProxyAddress optional discovery proxy to be used.
         */
        public fun create(
            udpMessageQueue: UdpMessageQueue,
            discoveryProxyAddress: URI?
        ): DiscoveryConsumer

        /**
         * @param udpMessageQueue a UDP message queue used to capture and send UDP messages in ad-hoc mode.
         */
        public fun create(
            udpMessageQueue: UdpMessageQueue
        ): DiscoveryConsumer
    }

    /**
     * Subscribes to discovery events.
     */
    public suspend fun subscribe(): ReceiveChannel<DiscoveryEvent>

    /**
     * Searches for endpoints based on the search filter criteria.
     *
     * @param searchFilters the filter criteria to match.
     * @param maxResults the maximum number of search response messages before returning.
     *
     *                   Note that this number does not have any effect when using a discovery proxy as results
     *                   are not collected by means of an asynchronous UDP multicast data exchange.
     * @return a [Deferred] providing the search results as a list of matching endpoints.
     */
    public suspend fun searchAsync(searchFilters: Collection<SearchFilter>, maxResults: Int): DeferredSearchResult<List<Endpoint>>

    /**
     * Searches for endpoints based on a single search filter element.
     *
     * @param searchFilter the filter element to match.
     * @param maxResults the maximum number of search response messages before returning.
     *
     *                   Note that this number does not have any effect when using a discovery proxy as results
     *                   are not collected by means of an asynchronous UDP multicast data exchange.
     * @return a [Deferred] providing the search results as a list of matching endpoints.
     */
    public suspend fun searchAsync(searchFilter: SearchFilter, maxResults: Int): DeferredSearchResult<List<Endpoint>>

    /**
     * Seeks the first endpoint based on a single search filter element.
     *
     * @param searchFilter the filter element to match.
     * @return a [Deferred] providing the search result.
     */
    public suspend fun searchAsync(searchFilter: SearchFilter): DeferredSearchResult<Result<Endpoint>>

    /**
     * Seeks the first endpoint based on an endpoint identifier.
     *
     * @param endpointIdentifier the endpoint identifier to match.
     * @return a [Deferred] providing the endpoint if found, or throwing [EndpointNotFoundException] otherwise.
     */
    public suspend fun searchByEndpointIdentifierAsync(endpointIdentifier: String): DeferredSearchResult<Result<Endpoint>>
}


